//
//  GamePlayLayer.m
//  CCBirdie
//
//  Created by Josh Smith on 8/12/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "GamePlayLayer.h"


@implementation GamePlayLayer

@synthesize score;

+(CCScene *) scene
{
	// 'scene' is an autorelease object.
	CCScene *scene = [CCScene node];
	
	// 'layer' is an autorelease object.
	GamePlayLayer *layer = [GamePlayLayer node];
	
	// add layer as a child to scene
	[scene addChild: layer];
	
	// return the scene
	return scene;
}

- (id) init {
    if ((self = [super init])) {
        self.isTouchEnabled = YES;
        AppDelegate *ap = [[UIApplication sharedApplication] delegate];
        CGSize size = [[CCDirector sharedDirector] winSize];
        
        //CCParticleSystemQuad *ps = [CCParticleSystemQuad particleWithFile:@"CCBackGroundParticles.plist"];
        //[self addChild:ps];
        
        self.score = 0;
        
        CCLabelBMFont *scoreLabel = [CCLabelBMFont labelWithString:[NSString stringWithFormat:@"Score: %d",self.score] fntFile:@"RoughTypewriterMenu.fnt"];

        scoreLabel.position = ccp(size.width - scoreLabel.contentSize.width * 1.5, size.height - 30);
        [self addChild:scoreLabel z:0 tag:1];

        
        CCMenu *backMenu = [MainMenuLayer backMenu];
        backMenu.position = [ap positionForKey:@"SettingsMenuBackButton"];
        [self addChild:backMenu];
        
        CCSprite *ship = [CCSprite spriteWithSpriteFrameName:@"CCbirdie.png"];
        CCParticleSystemQuad *driveFlame = [CCParticleSystemQuad particleWithFile:@"CCBirdieDriveFlame.plist"];
        [ship addChild:driveFlame];
        driveFlame.position = ccp(0,[ship contentSize].height / 2);
        
        [self addChild:ship z:0 tag:0];
        
        ship.position = [ap positionForKey:@"MainMenuShip"];
        
        [ship runAction:[CCMoveTo actionWithDuration:0.5 position:ccp(size.width / 2, size.height / 2)]];
        
                
    }
    [self schedule:@selector(generateObjects:) interval:0.25];
    [self schedule:@selector(collisionCheck:)];

    return self;
}

- (void) ccTouchesMoved:(NSSet *)touches withEvent:(UIEvent *)event {
    UITouch *touch = [touches anyObject];
    CGPoint location = [[CCDirector sharedDirector] convertToUI:[touch locationInView:[touch view]]];
    CCSprite *ship = (CCSprite *)[self getChildByTag:0];
    [ship runAction:[CCMoveTo actionWithDuration:0.25 position:ccp(ship.position.x, location.y)]];
}

-(void)ccTouchesEnded:(NSSet *)touches withEvent:(UIEvent *)event {
    UITouch *touch = [touches anyObject];
    CGPoint location = [[CCDirector sharedDirector] convertToUI:[touch locationInView:[touch view]]];
    CCSprite *ship = (CCSprite *)[self getChildByTag:0];
    [ship runAction:[CCMoveTo actionWithDuration:0.25 position:ccp(ship.position.x, location.y)]];
}

- (void) gameOver { 
    [self unschedule:@selector(generateObjects:)];
    [self unschedule:@selector(collisionCheck:)];
    [[CCDirector sharedDirector] replaceScene:[CCTransitionFade transitionWithDuration:1.0 scene:[GameOverLayer scene]]]; 
}

- (void) generateObjects: (ccTime) dt   {
    CGSize size = [[CCDirector sharedDirector] winSize];
    
    int prob = arc4random() % 100;
    float duration = (arc4random() % 14) + 5;
    if (prob < 3) {
        NSLog(@"Green!");
        CCSprite *green = [CCSprite spriteWithSpriteFrameName:@"CCgreenPowerUp copy.png"];
        green.userData = @"green";
        [self addChild:green];
        green.position = ccp(size.width + green.contentSize.width, arc4random() % (int)size.height);
        [green runAction:[CCMoveTo actionWithDuration:duration position:ccp(-1 * green.contentSize.width,green.position.y)]];
    } else if (prob >= 3 && prob < 5) {
        NSLog(@"Red!");
        CCSprite *red = [CCSprite spriteWithSpriteFrameName:@"CCredPowerDown.png"];        
        red.userData = @"red";
        [self addChild:red];        
        red.position = ccp(size.width + red.contentSize.width, arc4random() % (int)size.height);
        [red runAction:[CCMoveTo actionWithDuration:duration position:ccp(-1 * red.contentSize.width,red.position.y)]];
    } else if (prob >= 5 && prob < 8) {
        NSLog(@"Block!");
        CCSprite *block = [CCSprite spriteWithSpriteFrameName:@"CCbasicBlock.png"];
        [self addChild:block];
        block.position = ccp(size.width + block.contentSize.width, arc4random() % (int)size.height);
        block.userData = @"block";
        [block runAction:[CCMoveTo actionWithDuration:duration position:ccp(-1 * block.contentSize.width,block.position.y)]];
    }
}

- (void) collisionCheck:(ccTime) dt {
    CCSprite *ship = (CCSprite *)[self getChildByTag:0];
    NSPredicate *_green = [NSPredicate predicateWithFormat:@"self = %@",@"green"];
    NSPredicate *_red = [NSPredicate predicateWithFormat:@"self = %@",@"red"];
    NSPredicate *_block = [NSPredicate predicateWithFormat:@"self = %@",@"block"];
    
    for (CCSprite *other in [self children]) {
        if (CGRectContainsPoint(other.boundingBox, ship.position)) {
            if ([_green evaluateWithObject:(NSString *)other.userData]) {
                NSLog(@"ha ha Green Collision detected, %@ vs %@",NSStringFromCGRect(other.boundingBox),NSStringFromCGPoint(ship.position));
                CCLabelBMFont *scorelable = (CCLabelBMFont *)[self getChildByTag:1];
                self.score += 100;
                [scorelable setString:[NSString stringWithFormat:@"Score: %d",self.score]];
                [self removeChild:other cleanup:YES];                
            } else if ([_red evaluateWithObject:(NSString *)other.userData]) {
                NSLog(@"ha ha red Collision detected, %@ vs %@",NSStringFromCGRect(other.boundingBox),NSStringFromCGPoint(ship.position));
                CCLabelBMFont *scorelable = (CCLabelBMFont *)[self getChildByTag:1];
                self.score -= 100;
                [scorelable setString:[NSString stringWithFormat:@"Score: %d",self.score]];
                [self removeChild:other cleanup:YES];                
            } else if ([_block evaluateWithObject:(NSString *)other.userData]) {
                NSLog(@"ha ha red Collision detected, %@ vs %@",NSStringFromCGRect(other.boundingBox),NSStringFromCGPoint(ship.position));
                [self gameOver];
                [self removeChild:other cleanup:YES];
            }
        }
    }
}
@end
