//
//  MainMenuLayer.m
//  CCBirdie
//
//  Created by Josh Smith on 8/11/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "MainMenuLayer.h"


@implementation MainMenuLayer

+(CCScene *) scene
{
	// 'scene' is an autorelease object.
	CCScene *scene = [CCScene node];
	
	// 'layer' is an autorelease object.
	MainMenuLayer *layer = [MainMenuLayer node];
	
	// add layer as a child to scene
	[scene addChild: layer];
	
	// return the scene
	return scene;
}

- (id) init {
    
    if ((self = [super init])) {
        AppDelegate *ap = [[UIApplication sharedApplication] delegate];
        
        CCParticleSystemQuad *ps = [CCParticleSystemQuad particleWithFile:@"CCBackGroundParticles.plist"];
        [self addChild:ps];
        
        CCLabelBMFont *titleHead = [CCLabelBMFont labelWithString:@"Dodger!" fntFile:@"RoughTypewriter.fnt"];
        titleHead.position = [ap positionForKey:@"MainMenuTitleHead"];
        [self addChild:titleHead];

        CCLabelBMFont *playButton = [CCLabelBMFont labelWithString:@"Play Game" fntFile:@"RoughTypewriterMenu.fnt"];
        CCLabelBMFont *settingsButton = [CCLabelBMFont labelWithString:@"Settings" fntFile:@"RoughTypewriterMenu.fnt"];
        CCLabelBMFont *infoButton = [CCLabelBMFont labelWithString:@"What is this?" fntFile:@"RoughTypewriterMenu.fnt"];
        
        CCMenuItemLabel *playMenuItem = [CCMenuItemLabel itemWithLabel:playButton
                                                                 block:^(id sender) {
                                                                     [[CCDirector sharedDirector] replaceScene:[GamePlayLayer scene]];
                                                                 }];
        playMenuItem.position = [ap positionForKey:@"MainMenuPlayButton"];
        
        CCMenuItemLabel *settingsMenuItem = [CCMenuItemLabel itemWithLabel:settingsButton
                                                                     block:^(id sender) {
                                                                         [[CCDirector sharedDirector] replaceScene:[CCTransitionFade transitionWithDuration:1.0 scene:[SettingsMenuLayer scene]]];
                                                                     }];
        settingsMenuItem.position = [ap positionForKey:@"MainMenuSettingsButton"];
        
        CCMenuItemLabel *infoMenuItem = [CCMenuItemLabel itemWithLabel:infoButton
                                                                 block:^(id sender) {
                                                                       [[CCDirector sharedDirector] replaceScene:[CCTransitionFade transitionWithDuration:1.0 scene:[InfoLayer scene]]];
                                                                 }];
        infoMenuItem.position = [ap positionForKey:@"MainMenuInfoButton"];
        
        CCMenu *mainMenu = [CCMenu menuWithItems:playMenuItem,settingsMenuItem,infoMenuItem,nil];
        
        mainMenu.position = [ap positionForKey:@"MainMenuButtons"];
        [self addChild:mainMenu];
        
        [ap backgroundMusic];
        
        [[CCSpriteFrameCache sharedSpriteFrameCache] addSpriteFramesWithFile:@"CCbirdie.plist"];

        CCSprite *ship = [CCSprite spriteWithSpriteFrameName:@"CCbirdie.png"];
        CCParticleSystemQuad *driveFlame = [CCParticleSystemQuad particleWithFile:@"CCBirdieDriveFlame.plist"];
        [ship addChild:driveFlame];
        driveFlame.position = ccp(0,[ship contentSize].height / 2);
        
        [self addChild:ship];


        ship.position = [ap positionForKey:@"MainMenuShip"];
        
    }
    return self;
}

+ (CCMenu *) backMenu {
    CCLabelBMFont *backButton = [CCLabelBMFont labelWithString:@"Main Menu" 
                                                       fntFile:@"RoughTypewriterMenu.fnt"];
        CCMenuItemLabel *backButtonItem = [CCMenuItemLabel itemWithLabel:backButton
                                                                   block:^(id sender) {
                                                                       [[CCDirector sharedDirector] replaceScene:[CCTransitionFade transitionWithDuration:1.0 scene:[MainMenuLayer scene]]]; 
                                                                   }];
        CCMenu *backMenu = [CCMenu menuWithItems:backButtonItem, nil];
    return backMenu;
}

@end
