//
//  SettingsMenuLayer.m
//  CCBirdie
//
//  Created by Josh Smith on 8/12/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "SettingsMenuLayer.h"

@implementation SettingsMenuLayer

+(CCScene *) scene
{
	// 'scene' is an autorelease object.
	CCScene *scene = [CCScene node];
	
	// 'layer' is an autorelease object.
	SettingsMenuLayer *layer = [SettingsMenuLayer node];
	
	// add layer as a child to scene
	[scene addChild: layer];
	
	// return the scene
	return scene;
}

- (id) init {
    if ((self = [super init])) {
        AppDelegate *ap = [[UIApplication sharedApplication] delegate];
        CCLabelBMFont *titleHead = [CCLabelBMFont labelWithString:@"Settings" fntFile:@"RoughTypewriter.fnt"];
        titleHead.position = [ap positionForKey:@"SettingsMenuTitle"];
        [self addChild:titleHead];

        CCMenu *backMenu = [MainMenuLayer backMenu];
        backMenu.position = [ap positionForKey:@"SettingsMenuBackButton"];
        [self addChild:backMenu];
        
        CCLabelBMFont *playBackground = [CCLabelBMFont labelWithString:@"Play Background Music"
                                                               fntFile:@"RoughTypewriterMenu.fnt"];
        CCMenuItemLabel *playBackgroundButton = [CCMenuItemLabel itemWithLabel:playBackground];
        
        CCLabelBMFont *muteBackground = [CCLabelBMFont labelWithString:@"Mute Background Music"
                                                               fntFile:@"RoughTypewriterMenu.fnt"];
        CCMenuItemLabel *muteBackgroundButton = [CCMenuItemLabel itemWithLabel:muteBackground];
        
        CCMenuItemToggle *backgroundToggle;
        
        if (ap.playThemeMusic) {
            backgroundToggle = [CCMenuItemToggle itemWithBlock:^(id sender) {
                ap.playThemeMusic = !ap.playThemeMusic;
                [ap backgroundMusic];
            }
                                                         items:muteBackgroundButton,playBackgroundButton, nil];
        } else {
            backgroundToggle = [CCMenuItemToggle itemWithBlock:^(id sender) {
                ap.playThemeMusic = !ap.playThemeMusic;
                [ap backgroundMusic];
            }
                                                         items:playBackgroundButton,muteBackgroundButton, nil];
        }
        CCMenu *settings = [CCMenu menuWithItems: backgroundToggle,nil];
        settings.position = [ap positionForKey:@"SettingsMenuMuteMusicButton"];
        [self addChild:settings];
    }
    return self;    
}

@end
