//
//  DrumMachine.m
//  yourFirstGame
//
//  Created by Josh Smith on 8/12/11.
//  Copyright 2011 Joshua Smith. All rights reserved.
//

#import "DrumMachine.h"


@implementation DrumMachine

+(CCScene *) scene
{
	// 'scene' is an autorelease object.
	CCScene *scene = [CCScene node];
	
	// 'layer' is an autorelease object.
    DrumMachine *layer = [[self class] node];
	//layer.visible = NO;
	// add layer as a child to scene
	[scene addChild: layer];
	
	// return the scene
	return scene;
}

- (id) init {
    if ((self = [super init])) {
        
      NSArray *sounds = [NSArray arrayWithObjects:@"drumMachineSound.mp3",@"drumMachineSound1.mp3",@"drumMachineSound2.mp3",@"drumMachineSound3.mp3",@"drumMachineSound4.mp3",nil];
                           
        int ygrid = 0;
        
        CGFloat ystep = 20;
        CGPoint startPoint = ccp(100,300);

        CCMenu *soundBoard = [CCMenu menuWithItems: nil];
	soundBoard.position = startPoint;
        for (NSString *sound in sounds) {
            [[SimpleAudioEngine sharedEngine] preloadEffect:sound];                
            CCLabelTTF *label = [CCLabelTTF labelWithString:sound fontName:@"Rough_Typewriter" 
                                                   fontSize:20];
            
            CCMenuItemLabel *item = [CCMenuItemLabel itemWithLabel:label
                                                             block:^(id sender) {
                                                                 [[SimpleAudioEngine sharedEngine] playEffect:sound]; 
                                                             }];

            [soundBoard addChild:item];
            startPoint = ccp(startPoint.x, -1 * (ygrid * ystep));
            ygrid++;
            
            item.position = startPoint;
        }
        [self addChild:soundBoard];
        CCMenuItemToggle *toggle = [CCMenuItemToggle itemWithBlock:^(id sender){
            if ([[SimpleAudioEngine sharedEngine] isBackgroundMusicPlaying]) {
                [[SimpleAudioEngine sharedEngine] stopBackgroundMusic];
            } else {
                [[SimpleAudioEngine sharedEngine] playBackgroundMusic:@"2011-08-09 21.16.10.mp3"];
            }
        } 
                                                             items:[CCMenuItemFont itemFromString:@"Play"],[CCMenuItemFont itemFromString:@"Mute"], nil];
        
        CCMenu *backgroundmusic = [CCMenu menuWithItems:toggle, nil];
        
        [self addChild:backgroundmusic];
        CGSize size = [[CCDirector sharedDirector] winSize];
        backgroundmusic.position = ccp(size.width / 4, size.height / 4);

    }
    
    return self;
}

@end
