//
//  HelloWorldLayer.m
//  yourFirstGame
//
//  Created by Josh Smith on 8/10/11.
//  Copyright Joshua Smith 2011. All rights reserved.
//


// Import the interfaces
#import "HelloWorldLayer.h"

// HelloWorldLayer implementation
@implementation HelloWorldLayer

+(CCScene *) scene
{
	// 'scene' is an autorelease object.
	CCScene *scene = [CCScene node];
	
	// 'layer' is an autorelease object.
    id layer = [[self class] node];
	
	// add layer as a child to scene
	[scene addChild: layer];
	
	// return the scene
	return scene;
}

// on "init" you need to initialize your instance
-(id) init
{
	// always call "super" init
	// Apple recommends to re-assign "self" with the "super" return value
	if( (self=[super init])) {
		
		// create and initialize a Label
		CCLabelTTF *label = [CCLabelTTF labelWithString:@"Hello CocoaConf" fontName:@"Rough_Typewriter" fontSize:54];

		// ask director the the window size
		CGSize size = [[CCDirector sharedDirector] winSize];
	
		// position the label on the center of the screen
		label.position =  ccp( size.width /2 , size.height/2 );
		
		// add the label as a child to this Layer
		[self addChild: label];
        
        void (^nextAction)(id sender) = ^(id sender){
            [[CCDirector sharedDirector] replaceScene:[CCTransitionRotoZoom transitionWithDuration:3.0 scene:[AnimatedScene scene]]];
             };
        
        CCLabelTTF *nextButtonLabel = [CCLabelTTF labelWithString:@"Next!"
                                                         fontName:@"Rough_Typewriter"
                                                         fontSize:28];

        CCMenuItemFont *nextButton = [CCMenuItemFont itemWithLabel:nextButtonLabel
                                                             block:nextAction];
        CCMenu *nextMenu = [CCMenu menuWithItems:nextButton, nil];
        [self addChild:nextMenu];

        // We use Spawn instead of CCSequence so they happen at the same time.
        [nextMenu runAction:[CCSpawn actions:[CCFadeIn actionWithDuration:3.0],[CCMoveTo actionWithDuration:3.0 position:ccp(size.width / 4 * 3, size.height /4)],nil]];
	}
	return self;
}

// on "dealloc" you need to release all your retained objects
- (void) dealloc
{
	// in case you have something to dealloc, do it in this method
	// in this particular example nothing needs to be released.
	// cocos2d will automatically release all the children (Label)
	
	// don't forget to call "super dealloc"
	[super dealloc];
}
@end
